{
  Based on Mame and Pasmul
  If you have ideas or question
  please mail franzenm@web.de

}
unit
  UMAMEChr;

interface

  uses
    USprite,kbd,sysutils,windows,utils;

  const
    ORIENTATION_FLIP_X  = $80;
    ORIENTATION_FLIP_Y  = $40;
    ORIENTATION_SWAP_XY = $20;

  type
    cptable = array[0..2048] of Byte;
    ctable =^cptable;
    Int = LongInt;

    PMachine = ^TMachine;
    TMachine = record
      orientation: Int;
    end;

    TByte = array[0..65500] of Byte;
    PByte = ^TByte;

    PBitMapData = ^TBitMapData;
    TBitMapData = record
      line: PByte;
    end;

    PGFXLayout = ^TGFXLayout;
    TGFXLayout = record
      width,height: Int;              (* width and height of chars/sprites *)
      total: Int;                     (* total numer of chars/sprites in the rom *)
      planes: Int;                    (* number of bitplanes *)
      planeoffset: array[0..7] of Int; (* start of every bitplane *)
      xoffset: array[0..63] of Int;    (* coordinates of the bit corresponding to the pixel *)
      yoffset: array[0..63] of Int;    (* of the given coordinates *)
      charincrement: Int;              (* distance between two consecutive characters/sprites *)
    end;

   PGfxElement = ^TGfxElement;
   TGfxElement = record
     width,height: Int;
     gfxdata: PSpriteSet;        (* graphic data *)
     total_elements: Int;    (* total number of characters/sprites *)
     color_granularity: Int; (* number of colors for each color code *)
     colortable: Pointer;        (* map color codes to screen pens *)
     total_colors, nStartPalette: Int;
     cName: String[31];
     planes: Int;
   end;
   TArrayGfxElement = array[0..2048] of PGfxElement;
   PArrayGfxElement = ^TArrayGfxElement;


type key_matr_ = array[0..8] of byte; // 8 Bit
                // [0] ist der XOR wert
var  key_matrix
    ,DSW_matrix:array[0..10] of ^key_matr_;

    key_val:array[0..7] of key_matr_;
    DSW_VAL:array[0..7] of key_matr_;

    Paddle_x:byte=128;
    paddle_y:byte=128;

    machine_screen_height,
    machine_screen_width,
    visible_area_min_x,
    visible_area_max_x,
    visible_area_min_y,
    visible_area_max_y:integer;

    //color_shift_r:byte = 0;
    dirtyram    :pbyte;    // reserviert fr speicherspiegel
procedure FreeGFX(var gfx: PGFXElement);
function  DecodeGFX(cName: String;
                    nStartPalette: Integer;
                    oMachine: PMachine; // zb. xxxx.gfx[n]
                    src: PByte;         // quelle des PCG im ram oder rom
                    gl: PGfxLayout;     // @XXXX_charlayout
                    colortab:ctable): PGFXElement;

procedure DecodeChar(oMachine: PMachine;  // einzelzeichen encode
                     gfx: PGfxElement;// zb. xxxx.gfx[n]
                     num: Int;        // NR des zeichens
                     src: PByte;      // quelle des PCG
                     gl: PGfxLayout); // @XXXX_charlayout

function RGN_FRAC(num,den:integer):integer;   // mame

function BIT_(x,n:integer):byte;
function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;
function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;

const IP_ACTIVE_LOW     = 1;    // MAME NEW
      IP_ACTIVE_HIGH    = 0;
      IPT_UNUSED        = 0;
      IPT_UNKNOWN       = 0;
      IPT_START1        = VK_1;
      IPT_START2        = VK_2;
      //IPT_START3 = VK_3;
      IPT_COIN1         = VK_3;
      IPT_COIN2         = VK_4;
      IPT_COIN3         = VK_5;
      IPT_JOYSTICK_RIGHT= VK_right;
      IPT_JOYSTICK_LEFT = VK_left;
      IPT_JOYSTICK_DOWN = VK_down;
      IPT_JOYSTICK_UP   = VK_UP;
      IPT_BUTTON1       = VK_control;
      IPT_BUTTON2       = VK_shift;
      IPT_BUTTON3       = VK_space;
      IPT_TILT          = VK_0;
      IPT_VBLANK        = 255;

function lt_in(nr:byte):byte;
function lt_DSW(nr:byte):byte;




function input_port_0_r:byte;
function input_port_1_r:byte;
function input_port_2_r:byte;
function input_port_3_r:byte;
function input_port_4_r:byte;
function input_port_5_r:byte;
function input_port_6_r:byte;

procedure paddle_h(min,max:byte);

// OLD MAME
Procedure set_in(nr,default_val,a0,a1,a2,a3,a4,a5,a6,a7:byte);
procedure set_DSW(Nr,default_val,a0,a1,a2,a3,a4,a5,a6,a7:byte);

Procedure set_in_new(nr,
                        value1,typ1,key1,
                        value2,typ2,key2,
                        value3,typ3,key3,
                        value4,typ4,key4,
                        value5,typ5,key5,
                        value6,typ6,key6,
                        value7,typ7,key7,
                        value8,typ8,key8:integer);

// -------------------------------------------------
procedure MDRV_VISIBLE_AREA(minx, maxx, miny, maxy:integer);
procedure MDRV_SCREEN_SIZE(width, height:integer);

implementation

procedure MDRV_SCREEN_SIZE(width, height:integer);
begin
	machine_screen_width:=  (width);
	machine_screen_height:= (height);
end;

procedure MDRV_VISIBLE_AREA(minx, maxx, miny, maxy:integer);
begin
	visible_area_min_x:= (minx);
	visible_area_max_x:= (maxx);
	visible_area_min_y:= (miny);
	visible_area_max_y:= (maxy);
end;
var key_count:byte = 0;

procedure paddle_h(min,max:byte); // muss periodisch aufgerufen werden.
var i:byte;
begin
      i:=lt_in(2);
      Paddle_x:=Paddle_x+ord(i and 2)*3-ord(i and 1)*3;
      if Paddle_x < min then Paddle_x:=min;
      if Paddle_x > max then Paddle_x:=max;
end;


var default_in_0,           // HAT historische grnde
    default_DSW :array[0..10] of key_matr_;

procedure set_in(nr,default_val,a0,a1,a2,a3,a4,a5,a6,a7:byte);
var i:byte;
begin
      key_matrix[nr]:=@default_in_0[nr]; // ZEIGER AUF TABELLE LEGEN
      key_matrix[nr]^[0]:=default_val;   // GRUNDEINSTELLUNG DESPORTS
      key_matrix[nr]^[1]:=a0;
      key_matrix[nr]^[2]:=a1;
      key_matrix[nr]^[3]:=a2;
      key_matrix[nr]^[4]:=a3;
      key_matrix[nr]^[5]:=a4;
      key_matrix[nr]^[6]:=a5;
      key_matrix[nr]^[7]:=a6;
      key_matrix[nr]^[8]:=a7;
      for i:=0 to 7
         do
          key_val[nr][i]:=1 shl I;
end;

function bit_nr(eing:byte):byte;
var i:byte;
begin
     result:=0;
     for i:=0 to 7
     do
        if (eing shr i) and 1 = 1 then result:=i;
end;

Procedure set_in_new(nr,
                        value1,typ1,key1,
                        value2,typ2,key2,
                        value3,typ3,key3,
                        value4,typ4,key4,
                        value5,typ5,key5,
                        value6,typ6,key6,
                        value7,typ7,key7,
                        value8,typ8,key8:integer);
var i:byte;
begin
      key_matrix[nr]:=@default_in_0[nr]; // ZEIGER AUF TABELLE LEGEN
      key_matrix[nr]^[0]:=value1*typ1 or value2*typ2 or
                          value3*typ3 or value4*typ4 or
                          value5*typ5 or value6*typ6 or
                          value7*typ7 or value8*typ8;

      key_val[nr][0]:=value1; key_val[nr][1]:=value2;
      key_val[nr][2]:=value3; key_val[nr][3]:=value4;

      key_val[nr][4]:=value5; key_val[nr][5]:=value6;
      key_val[nr][6]:=value7; key_val[nr][7]:=value8;

      key_matrix[nr]^[1+bit_nr(value1)]:=key1;
      key_matrix[nr]^[1+bit_nr(value2)]:=key2;
      key_matrix[nr]^[1+bit_nr(value3)]:=key3;
      key_matrix[nr]^[1+bit_nr(value4)]:=key4;

      key_matrix[nr]^[1+bit_nr(value5)]:=key5;
      key_matrix[nr]^[1+bit_nr(value6)]:=key6;
      key_matrix[nr]^[1+bit_nr(value7)]:=key7;
      key_matrix[nr]^[1+bit_nr(value8)]:=key8;
end;

procedure set_DSW(Nr,default_val,a0,a1,a2,a3,a4,a5,a6,a7:byte);
//var i:byte;
begin
      DSW_matrix[nr]:= @default_DSW[NR];
      DSW_matrix[NR]^[0]:=default_val;
      DSW_matrix[NR]^[1]:=a0;
      DSW_matrix[NR]^[2]:=a1;
      DSW_matrix[NR]^[3]:=a2;
      DSW_matrix[NR]^[4]:=a3;
      DSW_matrix[NR]^[5]:=a4;
      DSW_matrix[NR]^[6]:=a5;
      DSW_matrix[NR]^[7]:=a6;
      DSW_matrix[NR]^[8]:=a7;
     (*
      for i:=0 to 7
         do
          dsw_val[i]:=1 shl I;
     *)
end;


function lt_in(nr:byte):byte;
var rv:byte;
    i,val:byte;
begin             // IPT_VBLANK
    rv:=0;
    for i:=0 to 7
    do
     begin
      val:=key_[key_matrix[nr]^[i+1]];

      rv:=rv or val * key_val[nr][i];
      // if nr = 0 then write(inttohex(key_val[0][i],2)+' ');
     end;
    //writeln('');
    result:=key_matrix[nr]^[0] xor rv;
end;


function input_port_0_r:byte;
begin
    result:=lt_in(0);
end;

function input_port_1_r:byte;
begin
    result:=lt_in(1);
end;

function input_port_2_r:byte;
begin
    result:=lt_in(2);
end;

function input_port_3_r:byte;
begin
    result:=lt_in(3);
end;

function input_port_4_r:byte;
begin
    result:=lt_in(4);
end;

function input_port_5_r:byte;
begin
    result:=lt_in(5);
end;

function input_port_6_r:byte;
begin
    result:=lt_in(6);
end;

function lt_DSW(nr:byte):byte;
var rv:byte;
    i,val:byte;
begin
    rv:=0;
    for i:=0 to 7
    do
    begin
      val:=key_[DSW_matrix[nr]^[i+1]];
      rv:=rv or val shl i;
    end;
    result:=DSW_matrix[nr]^[0] xor rv;
end;


function BIT_(x,n:integer):byte;
begin
   result:=(x shr n) and 1;
end;

function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;
begin
            result:=
		 (bit_(val,B7)  shl  7)  or
		 (bit_(val,B6)  shl  6)  or
		 (bit_(val,B5)  shl  5)  or
		 (bit_(val,B4)  shl  4)  or
		 (bit_(val,B3)  shl  3)  or
		 (bit_(val,B2)  shl  2)  or
		 (bit_(val,B1)  shl  1)  or
		 (bit_(val,B0)  shl  0);

end;

function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;
begin
		result:=
                ((bit_(val,B15)  shl  15)  or
		 (bit_(val,B14)  shl  14)  or
		 (bit_(val,B13)  shl  13)  or
		 (bit_(val,B12)  shl  12)  or
		 (bit_(val,B11)  shl  11)  or
		 (bit_(val,B10)  shl  10)  or
		 (bit_(val, B9)  shl   9)  or
		 (bit_(val, B8)  shl   8)  or
		 (bit_(val, B7)  shl   7)  or
		 (bit_(val, B6)  shl   6)  or
		 (bit_(val, B5)  shl   5)  or
		 (bit_(val, B4)  shl   4)  or
		 (bit_(val, B3)  shl   3)  or
		 (bit_(val, B2)  shl   2)  or
		 (bit_(val, B1)  shl   1)  or
		 (bit_(val, B0)  shl   0))
end;


function RGN_FRAC(num,den:integer):integer;
begin
 result:=($80000000 or (((num) and $0f) shl 27) or (((den) and $0f) shl 23));
end;

function readbit(src: PByte; bitnum: Int): Int;
begin
  readbit :=(src^[bitnum div 8] shr (7 - (bitnum mod 8))) and 1;
end;


procedure DecodeChar(oMachine: PMachine; gfx: PGfxElement; num: Int;
                     src: PByte; gl: PGfxLayout);
var
  temp,
  xoffs,
  yoffs,
  offs,
  x,
  y,
  planebit,
  nPlane: Int;
  dp: PByte;
begin
  for nPlane := 0 to gl^.planes-1 do begin
    planebit:= 1 shl (gl^.planes - 1 - nplane);
    offs := num * gl^.charincrement + gl^.planeoffset[nPlane];
    for y := 0 to gfx^.height-1 do
    begin
      dp := @gfx^.gfxdata^[num]^.aData[y*gfx^.width];
      for x := 0 to gfx^.width-1 do
      begin
        xoffs := x;
        yoffs := y;
        if (oMachine^.orientation and ORIENTATION_FLIP_X)<>0 then
          xoffs := gfx^.width-1 - xoffs;

        if (oMachine^.orientation and ORIENTATION_FLIP_Y)<>0 then
          yoffs := gfx^.height-1 - yoffs;

        if (oMachine^.orientation and ORIENTATION_SWAP_XY)<>0 then begin
          temp := xoffs;
          xoffs := yoffs;
          yoffs := temp;
        end;

         if (nPlane=0) then dp^[x] := 0;

         if readbit(src,offs + gl^.yoffset[yoffs] + gl^.xoffset[xoffs]) > 0
         then dp^[x] := dp^[x] or planebit;
      end;
    end;
  end;
end;


procedure FreeGFX(var gfx: PGFXElement);
var
  I: Int;
begin
  for i := 0 to gfx^.total_elements-1 do
  FreeMem(gfx^.gfxdata^[i], 2*SizeOf(Int)+gfx^.height*gfx^.width);
  FreeMem(gfx^.gfxdata, gfx^.total_elements*SizeOf(PSprite));
  FreeMem(gfx, SizeOf(TGFXElement));
end;


function DecodeGFX(cName: String; nStartPalette: Integer; oMachine: PMachine; src: PByte; gl: PGfxLayout;colortab:ctable): PGFXElement;
var
  C: Int;
  gfx: PGFXElement;
  oSpriteSet: PSpriteSet;
begin
  GetMem(gfx, SizeOf(TGFXElement));
  if (oMachine^.orientation and ORIENTATION_SWAP_XY)<>0 then begin
    gfx^.width := gl^.height;
    gfx^.height := gl^.width;
  end
  else begin
    gfx^.width := gl^.width;
    gfx^.height := gl^.height;
  end;
  gfx^.planes:=gl^.planes;

  GetMem(oSpriteSet, gl^.total*SizeOf(PSprite));

  gfx^.total_elements := gl^.total;
  gfx^.color_granularity := 1 shl gl^.planes;
  gfx^.gfxdata := oSpriteSet;
  for c := 0 to gl^.total-1 do begin
    GetMem(oSpriteSet^[c], 2*SizeOf(Int)+gfx^.height*gfx^.width);
    oSpriteSet^[c]^.W := gfx^.width;
    oSpriteSet^[c]^.H := gfx^.height;
    decodechar(oMachine, gfx, c, src, gl);
  end;
  gfx^.cName := cName;
  gfx^.nStartPalette := nStartPalette;
  gfx^.colortable:=colortab;
  DecodeGFX := gfx;
end;


end.