unit Uterminal;

interface
uses
   USprite, UMAMEChr,UDIBSurf, Windows, m0609fnt,SysUtils;

(*
  CP/M terminal VT52 + VT100Part (c) by M.Franzen 08
*)
procedure refresh_cpm_crt;pascal;
procedure write_vt52(eing:string);
procedure write_char(eing:byte);
procedure gotoxy_VT52(x,y:byte);
procedure vt52color(v,b:byte);

procedure reset_terminal;



type v_arry = array[0..(132-1)*(50+1)] of byte;
var blink_count:byte;
    vmem,dirty,
    amem:^v_arry;
    TLines  :byte= 24; // mu noch verbessert werden
    TCOLUMS :byte= 80;
    screensize:word;

implementation


const
    UM = #10+#13;
    VT100    = 1;
    VT52     = 0;
    ROBOTRON = 2;

var tmode:byte;




var // VT52 var
    cursor_vis,cur_x,cur_y,x_alt,y_alt,vorl,
    color_v,color_b,v_alt,b_alt:byte;

    ESC_start:word;

    val1,val2:byte;
    retc:integer;
    echo,
    auto_scroll:byte;



procedure reset_terminal;
begin
     write_char(12); // CLS and HOME
     color_v:=5;color_b:=1;
     echo:=0;
     tmode:=VT52;
     cursor_vis:=1;
     esc_start:=0;
     auto_scroll:=1;
     TLines:= 24;
     TCOLUMS:= 80;
     screensize:=TCOLUMS*(TLines+1);
end;

procedure refresh_cpm_crt; pascal;
var x,y:word;
begin

  //dirty^[cur_x+cur_y*TCOLUMS]:=64;
     for x:=0 to (TCOLUMS-1)
      do
        for y:=0 to TLines
          do
             begin
              // if dirty^[x+y*TCOLUMS] <> rom^[x+y*TCOLUMS]
              //   then
                   begin
                        dirty^[x+y*TCOLUMS]:=rom^[x+y*TCOLUMS];
                        write_char_c(x,y,vmem^[x+y*TCOLUMS],amem^[x+y*TCOLUMS] and 15,amem^[x+y*TCOLUMS] shr 4);
                   end;
             end;
        if cursor_vis = 1
        then
            if blink_count mod 30 <= 15 then write_char_c(cur_x,cur_y,vmem^[cur_x+cur_y*TCOLUMS],color_b,12);
end;

procedure write_vt52(eing:string);
var i:byte;
begin
    for i:=1 to length(eing)
     do
       write_char(ord(eing[I]));
end;

procedure gotoxy_VT52(x,y:byte);
begin
       cur_y:=y;cur_x:=x;
       dirty^[cur_x+cur_y*TCOLUMS]:=64;
end;

procedure vt52color(v,b:byte);
begin
     color_v:=v;color_b:=b;
end;

procedure insert_line(lines:byte);
begin
      if (lines = 0) or (lines > TLines) then exit;
      // Zeilen verschieben
      move(vmem^[cur_y*TCOLUMS],vmem^[(lines+cur_y)*TCOLUMS],((TLines+1)-cur_y-lines)*TCOLUMS);
      move(amem^[cur_y*TCOLUMS],amem^[(lines+cur_y)*TCOLUMS],((TLines+1)-cur_y-lines)*TCOLUMS);

      // Zeilen lschen
      fillchar(vmem^[cur_y*TCOLUMS],lines*TCOLUMS,32);
      fillchar(amem^[cur_y*TCOLUMS],lines*TCOLUMS,color_b shl 4);

      fillchar(dirty^[0],$4000,64);
      esc_start:= 0;
end;

procedure del_line(lines:byte);
begin
     // del a line.

     if (lines = 0) or (lines > TLines) then exit;
      // Zeilen verschieben

     move(amem^[(lines+cur_y)*TCOLUMS],amem^[cur_y*TCOLUMS],((TLines+1)-cur_y-lines)*TCOLUMS);
     move(vmem^[(lines+cur_y)*TCOLUMS],vmem^[cur_y*TCOLUMS],((TLines+1)-cur_y-lines)*TCOLUMS);

     fillchar(rom^[((TLines+1)-lines)*TCOLUMS],TCOLUMS*lines,32);
     fillchar(amem^[((TLines+1)-lines)*TCOLUMS],TCOLUMS*lines,color_b shl 4);

     fillchar(dirty^[0],$4000,64);
     esc_start:= 0;
end;
procedure write_char(eing:byte);
var i,y:byte;
begin

    // if eing = 27 then writeln;
    // if esc_start > 0  then write(' [',esc_start,'] '+chr(eing)) else write((*'[',eing,'] ',*)chr(eing));

     if eing = 24 then begin esc_start:=0 ;exit; end; // Cancels an Escape sequence.
     case esc_start
     of
     3:begin cur_y:=eing-32;esc_start:=4;end; // VT52
     4:begin cur_x:=eing-32;esc_start:=0;end;

     33:begin cur_y:=eing;esc_start:=34;end; // VT100 ?
     34:begin cur_x:=eing;esc_start:=0;end;

     5:begin // ESC [
            tmode:= VT100;
            vorl:=eing;
            esc_start:=1;
            case chr(eing)
            of
              'A':begin if cur_y > 0  then inc(cur_y); esc_start:=0; end;// Cursor Up
              'B':begin if cur_y < TLines then dec(cur_y); esc_start:=0; end;// Cursor down
              'C':begin if cur_x < (TCOLUMS-1) then inc(cur_x); esc_start:=0; end;// Cursor Right
              'D':begin if cur_x > 0  then dec(cur_x); esc_start:=0; end;// Cursor Left
              'L':write_char(ord('L'));
              'M':write_char(ord('M'));
              'i':begin  // print screen
                      for y:=0 to TLines
                       do
                         begin
                              for i:=0 to (TCOLUMS-1)
                                  do writeln(chr(vmem^[y*TCOLUMS+i]));//LPT_out(vmem^[y*TCOLUMS+i]);
                                     writeln(#13); //lpt_out(13);
                         end;
                        esc_start:=0;
                  end;
              'm':begin
                      color_v:=5;color_b:=1;
                      esc_start:=0;
                 end;
              'f',
              'H':write_char(ord('H')); // home
              'J':write_char(ord('J')); // cls to end screen
              'd':write_char(ord('d')); // cls begin to cursor
              's':write_char(ord('7')); // Position und Attribute speichern
              'e':write_char(ord('8')); // Position und Attribute wiederherstellen
              'K':write_char(ord('K')); // bis zeilenende lschen
              'P':write_char(ord('P')); // ein zeichen lschen
              '0','1','2','3','4','5','6','7','8',
              '9':esc_start:=6;
              '?':esc_start:=12;
            else
                begin
                     write_vt52('  UNKNOWN DISPLAY CODE '+inttostr(eing)+'('+chr(eing)+')');
                     esc_start:=0;
                end;
            end;
       end;
     6:begin

            esc_start:=1;
            val(chr(vorl),val1,retc);
            //writeln('YYY :',chr(vorl),' ',chr(eing));
            case chr(eing)
            of
              'L':insert_line(val1);
              'M':del_line(val1);
              'P':write_vt52('missing funktion ESC [nP');
              'A','B','C','D': // move cursor
                  begin

                      case char(eing)
                      of
                       'A':begin if cur_y > val1    then inc(cur_y,val1); esc_start:=0; end;// Cursor Up
                       'B':begin if cur_y > (TLines+1)-val1 then dec(cur_y,val1); esc_start:=0; end;// Cursor down
                       'C':begin if cur_x < TCOLUMS-val1 then inc(cur_x,val1); esc_start:=0; end;// Cursor Right
                       'D':begin if cur_x > val1    then dec(cur_x); esc_start:=0; end;// Cursor Left
                      end;
                  end;
              'J':case chr(vorl)
                  of
                    '0':write_char(ord('J'));
                    '1':write_char(ord('d'));
                    '2':write_char(ord('E'));
                  end;

              'm':case chr(vorl)
                  of
                    '0':write_char(ord('p'));
                    '1':write_char(ord('q'));
                    '7':begin // Invers
                             color_v:=2;color_b:=6 ;
                             esc_start:=0;
                        end;
                  end;
              'i':case chr(vorl) // print line
                  of
                    '1':begin for i:=0 to (TCOLUMS-1) do writeln(chr(vmem^[cur_y*TCOLUMS+i]));writeln(#13)(*LPT_out(vmem^[cur_y*TCOLUMS+i]);lpt_out(13)*); esc_start:=0; end;
                    '5':begin echo:=1; esc_start:=0; end;
                    '4':begin echo:=0; esc_start:=0; end;
                  end;
              'K':case chr(vorl)
                  of
                    '0':esc_start:=0;
                    '1':write_char(ord('o'));
                    '2':write_char(ord('1'));
                  end;
               ';':esc_start:=9; // Nur eine stelle
               '0','1','2','3','4','5','6','7','8',
               '9':begin
                        val(chr(vorl)+chr(eing),val1,retc);
                        esc_start:=8;
                   end;
            end;
       end;

     8:begin
            case char(eing)
            of
              ';':begin  // nchster parameter
                      esc_start:=9;
                  end;
               else esc_start:=0
            end;
       end;
     9:begin
           CASE chr(eing)
           of
               '0','1','2','3','4','5','6','7','8',
               '9':begin
                        vorl:=eing;
                        esc_start:=200;
                   end;
           end
       end;
       200:begin  // mu verbessert werden !!!!
           val(chr(vorl),val2,retc);

           CASE chr(eing)
           of
               '0','1','2','3','4','5','6','7','8',
               '9':begin
                        val(chr(vorl)+chr(eing),val2,retc);
                        esc_start:=201;
                   end;
               'H','f':
               begin
                    //writeln('< ',val2,' ',val1,' >');
                    cur_x:=val2;
                    cur_y:=val1;
                    esc_start:=0;
               end;
           else
              esc_start:=0;
           end
       end;
     201:begin
              case chr(eing)
              of
               'H','f':
               begin
                    cur_x:=val2;
                    cur_y:=val1;
               end;
              end;
             esc_start:=0;
         end;

     7:begin // VT 100
             case chr(eing)
              of
             '8':begin  // testmuster ESC # 8
                      fillchar(vmem^[0],screensize,ord('E'));
                      fillchar(amem^[0],screensize,color_b);
                      fillchar(dirty^[0],screensize,64);
                 end;
             end;
             esc_start:=0;
       end;

     10:begin  // Kaypro was machen die ???
            esc_start:=1;
            case chr(eing)
            of
              '1','0':case chr(vorl)
                  of
                    'B':write_char(ord('p'));
                    'C':write_char(ord('q'));
                  end;
           end;
        end;

     11:begin
             esc_start:= 0;
             //writeln(chr(eing));
        end;
     120:begin
              esc_start:=0;
              case chr(vorl)
              of
                '3':begin
                    if chr(eing) = 'h'
                    then
                      begin
                         TLines:= 25;
                         TCOLUMS:= 132;
                       end
                     else
                     begin
                        TLines:= 25;
                        TCOLUMS:= 80;
                      end;
                     screensize:=TCOLUMS*(TLines+1);
                     EMU_screen.CreateDIB('cpm',TCOLUMS*8,(TLines+1)*13,0);
                    end;
              end;
         end;
     12:begin  // [?]  2 byte
           esc_start:=120;
           vorl:=eing;
       end;
     100:begin  // KC color ?
              color_v:=((eing - ord('1')) and 15);  // ???
              esc_start:= 0;
         end;
     101:begin
            case chr(vorl)
            of
              'b':color_v:=eing mod 16; // ESC b (Schriftfarbe whlen)
              'c':color_b:=eing mod 16; // ESC c (Hintergrundfarbe whlen)
            end;
            esc_start:=0;
         end;

     233:begin
              esc_start:= 0;
              case  eing
              of
                16:esc_start:=3;
              ELSE
               begin
                write_char(eing);
                //WRITEln('>>> Unknown 233 kode :'+inttostr(eing)+'['+chr(eing)+']');
               end;
              end;
         end;
     // KC y,x
     103:begin cur_x:=eing-$80;esc_start:=0;end;
     1:
         begin
              case chr(eing)
              of
              ' ':esc_start:=0;
              //'3',:esc_start:=0;
              '[':esc_start:=5; // DECT VT100
              'Y':esc_start:= 3;
              'e':begin esc_start:=0;cursor_vis:=1;end;
              'f':begin cursor_vis:=0; esc_start:=0;end;
              'E':begin fillchar(vmem^[0],TCOLUMS*(TLines+1),32);
                        fillchar(dirty^[0],TCOLUMS*(TLines+1),64);
                        fillchar(amem^[0],TCOLUMS*(TLines+1),color_b shl 4);
                        cur_x:=0;cur_y:=0; // macht er das so ?
                        esc_start:=0 ;
                  end;
              'J':begin fillchar(vmem^[cur_x+cur_y*TCOLUMS],TCOLUMS*(TLines+1)-cur_x-cur_y*TCOLUMS,32);
                        fillchar(dirty^[cur_x+cur_y*TCOLUMS],80*(TLines+1)-cur_x-cur_y*80,64);
                        fillchar(amem^[cur_x+cur_y*TCOLUMS],TCOLUMS*(TLines+1)-cur_x-cur_y*TCOLUMS,color_b shl 4);
                        esc_start:= 0;
                  end;
              'd':begin fillchar(vmem^[0],cur_x+cur_y*TCOLUMS,32);
                        fillchar(dirty^[0],cur_x+cur_y*TCOLUMS,64);
                        fillchar(amem^[0],cur_x+cur_y*TCOLUMS,color_b shl 4);
                        esc_start:= 0;
                  end;
              'o':begin fillchar(vmem^[cur_y*TCOLUMS],cur_x,32); // Zeilenanfang lschen
                        fillchar(dirty^[cur_y*TCOLUMS],cur_x,64);
                        fillchar(amem^[cur_y*TCOLUMS],cur_x,color_b shl 4);
                        esc_start:= 0;
                  end;
              'K':begin fillchar(vmem^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x,32);
                        fillchar(dirty^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x,64);
                        fillchar(amem^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x,color_b shl 4);
                        esc_start:= 0;
                  end;
              'l':begin fillchar(vmem^[cur_y*TCOLUMS],TCOLUMS,32); // (Zeile lschen)
                        fillchar(dirty^[cur_y*TCOLUMS],TCOLUMS,64);
                        fillchar(amem^[cur_y*TCOLUMS],TCOLUMS,color_b shl 4);
                        cur_x:=0;
                        esc_start:= 0;
                  end;
              '1':begin fillchar(vmem^[cur_y*TCOLUMS],TCOLUMS,32);
                        fillchar(dirty^[cur_y*TCOLUMS],TCOLUMS,64);
                        fillchar(amem^[cur_y*TCOLUMS],TCOLUMS,color_b shl 4);
                        esc_start:= 0;
                  end;
              'H':begin cur_x:=0;cur_y:=0;esc_start:=0 ;dirty^[0]:=64;end;

              'L':Insert_line(1);
              'M':del_line(1);
              ')', // osborne
              'T',  // ESC p is the Heathkit H19 sequence
              'p':begin
                       color_v:=5 ;color_b:=1 ;
                       esc_start:= 0
                  end;
              '(', // osborne               sad
              'U',  // ESC q is the Heathkit H19 sequence
              'q':begin
                        color_v:=11;color_b:=1 ;
                        esc_start:= 0
                  end;
              'B',
              'C':begin esc_start:=10; vorl:=eing; end; // Kaypro
              'b',
              'c':begin esc_start:=101; vorl:=eing; end; // set color
              '7':begin // Position und Attribute speichern
                        esc_start:=0;
                        x_alt:=cur_x;   y_alt:=cur_y;
                        v_alt:=color_v; b_alt:=color_b;
                        dirty^[cur_x+cur_y*TCOLUMS]:=64;
                  end;
              'j':begin // Position speichern
                        esc_start:=0;
                        x_alt:=cur_x;   y_alt:=cur_y;
                        dirty^[cur_x+cur_y*TCOLUMS]:=64;
                  end;
              '8':begin
                        esc_start:=0;
                        cur_x:=x_alt;   cur_y:=y_alt;
                        color_v:=v_alt; color_b:=b_alt;
                        dirty^[cur_x+cur_y*TCOLUMS]:=64;
                  end;
              'k':begin
                        esc_start:=0;
                        cur_x:=x_alt;   cur_y:=y_alt;
                        dirty^[cur_x+cur_y*TCOLUMS]:=64;
                  end;
              '=':begin  // NL + ret
                      // cur_x:=0; inc(cur_y); esc_start:=0;
                      // dirty^[cur_y*TCOLUMS]:=64;
                      esc_start:=3;  // xerox 860 Direct cursor addressing (line - 32/column -32 number) as VT52
                  end;
              'y':// Direct cursor addressing (line/column number) VT100 ?
                   esc_start:=33;
              'm':begin // scroll up screen    ist im VT100 aber groes M !!!
                        move(amem^[TCOLUMS],amem^[0],screensize);
                        move(vmem^[TCOLUMS],vmem^[0],screensize);
                        fillchar(vmem^[TLines*TCOLUMS],TCOLUMS,32);
                        fillchar(amem^[TLines*TCOLUMS],TCOLUMS,color_b shl 4);
                        fillchar(dirty^[0],$4000,64);
                        esc_start:=0;
                   end;
              'D':begin // scroll down screen   VT100
                        move(amem^[0],amem^[TCOLUMS],screensize);
                        move(vmem^[0],vmem^[TCOLUMS],screensize);
                        fillchar(vmem^[0],TCOLUMS,32);
                        fillchar(amem^[0],TCOLUMS,color_b shl 4);
                        fillchar(dirty^[0],$4000,64);
                        esc_start:=0;
                   end;

              'z':begin // cls   via VT52
                         esc_start:=1;
                         write_char(ord('H'));  // home
                         esc_start:=1;
                         write_char(ord('E'));  // clear Vmem
                    end;

                //'A':if cur_y < TLines then inc(cur_y); // Cursor Up
                //'B':if cur_y > 0  then dec(cur_y); // Cursor down
                //'C':if cur_x < (TCOLUMS-1) then inc(cur_x); // Cursor Right
                //'D':if cur_x > 0  then dec(cur_x); // Cursor Left
               '#':esc_start:=7;
               't':esc_start:=11;
               'v':begin  // televideo
                        auto_scroll:=0 ;
                        esc_start:=0;
                   end;
               'w':begin  // televideo
                        auto_scroll:=1;
                        esc_start:=0;
                   end;
               'X':esc_start:=0; // reset printer c
               '*':esc_start:=0; // ???
               //')','(':  esc_start:=0; // VT100 fontselect
               #128..#255:begin  // KC cursor
                              cur_y:=eing-$80;
                              esc_start:=103; // x-wert erwarten !!
                       end;
              else
               begin
                   write_vt52('ESC + # '+chr(eing)+' ');  esc_start:=0;
               end;
              end;

         end;
     0:
     begin
     if echo = 1 then if char(eing) in [#10,#13,#32..#255] then  writeln(chr(eing));//lpt_out(eing);
     if eing < 32
       then
          begin
               case eing
               of
                 0:begin esc_start:=233; end;  // amstrad ??
                 //0:begin writeln; esc_start:=33; end;//???
                 1:write_char(ord('H'));  // home
                 2:begin // ClearEOL
                         esc_start:=1;
                         write_char(ord('K'));
                   end;
                 3:begin // ClearEOS
                         esc_start:=1;
                         write_char(ord('J'));
                   end;
                 7:;//begin winsound(1,1000,128,64);sleep(100);noteoff(1); end;// bell
                 8:if cur_x > 0 then  // lsche zeichen links vom cursor
                     begin
                         dec(cur_x);
                         move(vmem^[cur_x+1+cur_y*TCOLUMS],vmem^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x);
                         move(dirty^[cur_x+1+cur_y*TCOLUMS],dirty^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x);
                         move(amem^[cur_x+1+cur_y*TCOLUMS],dirty^[cur_x+cur_y*TCOLUMS],TCOLUMS-cur_x);
                         vmem^[(TCOLUMS-1)+cur_y*TCOLUMS]:=32; dirty^[(TCOLUMS-1)+cur_y*TCOLUMS]:=64; amem^[(TCOLUMS-1)+cur_y*TCOLUMS]:=color_b;
                         dirty^[cur_x+cur_y*TCOLUMS]:=64;
                     end;
                 10:begin; inc(cur_y);dirty^[cur_x+cur_y*TCOLUMS]:=64; end;
                 13:begin  cur_x:=0; dirty^[cur_y*TCOLUMS]:=64; end;
                 12,26:begin // cls   via VT52
                         esc_start:=1;
                         write_char(ord('H'));  // home
                         esc_start:=1;
                         write_char(ord('E'));  // clear Vmem
                    end;
                 14:begin // rnormal
                         esc_start:=1;
                         write_char(ord('U'));
                     end;
                 15:begin // reverse
                         esc_start:=1;
                         write_char(ord('T'));
                    end;
                 21:if cur_x < (TCOLUMS-1) then inc(cur_x); // Setzen Cursor um eine Position nach rechts
                 //26:begin if cur_y > 0  then dec(cur_y); end;
                 22:begin //Lschen ab Cursorposition bis Zeilenende
                         esc_start:=1 ;
                         write_char(ord('K'));
                     end;
                 24:begin  //Lschen Cursorzeile und setzen Cursor an den Zeilenanfang
                         esc_start:=1 ;
                         cur_x:=0;
                         write_char(ord('M'));
                    end;
                 27:esc_start:=1;
                 20:esc_start:=100; // KC color code
               else
                 ;// writeln(' ## ',eing);
               end;
          end
     else
        begin
             vmem^[cur_x+cur_y*TCOLUMS]:=eing;
             amem^[cur_x+cur_y*TCOLUMS]:=(color_v and $F) or (color_b and $F) shl 4;
             inc(cur_x);
             dirty^[cur_x+cur_y*TCOLUMS]:=64;
        end;

     if cur_x = TCOLUMS then begin cur_x:=0; inc(cur_y); dirty^[cur_y*TCOLUMS]:=64; end;
     if cur_y = (TLines+1) then
              begin
                   cur_y:=TLines; // scroll up
                   if auto_scroll = 1
                      then
                         begin
                              esc_start:=1;
                              write_char(ord('m'));
                         end;
              end;
     end;
     end;
end;


end.
